<?php

namespace App\Http\Controllers;

use App\Models\Ubicacion;
use Illuminate\Http\JsonResponse;
use Illuminate\Http\Request;

class UbicacionController extends Controller
{
    /**
     * Display a listing of the resource.
     */
    public function index(): JsonResponse
    {
        $items = Ubicacion::all();

        return response()->json([
            'success' => true,
            'data' => $items,
            'message' => 'Registros obtenidos correctamente',
        ], 200);
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(Request $request): JsonResponse
    {
        $payload = $request->only((new Ubicacion())->getFillable());
        $ubicacion = Ubicacion::create($payload);

        return response()->json([
            'success' => true,
            'data' => $ubicacion,
            'message' => 'Registro creado correctamente',
        ], 201);
    }

    /**
     * Display the specified resource.
     */
    public function show(Ubicacion $ubicacion): JsonResponse
    {
        return response()->json([
            'success' => true,
            'data' => $ubicacion,
            'message' => 'Registro obtenido correctamente',
        ], 200);
    }

    /**
     * Update the specified resource in storage.
     */
    public function update(Request $request, Ubicacion $ubicacion): JsonResponse
    {
        $payload = $request->only((new Ubicacion())->getFillable());
        $ubicacion->update($payload);

        return response()->json([
            'success' => true,
            'data' => $ubicacion,
            'message' => 'Registro actualizado correctamente',
        ], 200);
    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy(Ubicacion $ubicacion): JsonResponse
    {
        $ubicacion->delete();

        return response()->json([
            'success' => true,
            'message' => 'Registro eliminado correctamente',
        ], 200);
    }
}